diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 341ec886f..4cf988695 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -24,7 +24,7 @@ public class ItemBed extends Item {
             pos = pos.add(side.getDirection(), new TilePos());
         }
         Direction dir = player == null ? Direction.NORTH : player.getHorizontalPlacementDirection(null).getOpposite();
-        TilePos pos2 = pos.add(dir, new TilePos());
+        TilePos pos2 = pos.sub(dir, new TilePos());
         if (world.isAirBlock(pos) && world.isAirBlock(pos2) && world.canPlaceOnSurfaceOfBlock(pos.down(new TilePos())) && world.canPlaceOnSurfaceOfBlock(pos2.down(new TilePos()))) {
             if (world.canBlockIdBePlacedAt(Blocks.BED.id(), pos, false, side) && selfStack.consumeItem(player)) {
                 world.playBlockSoundEffect(player, pos.x() + 0.5F, pos.y() + 0.5F, pos.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 31532ba9d..01e0b0fa7 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -64,11 +64,11 @@ public final class NamespaceID implements Comparable<NamespaceID>, CharSequence,
     private @Nullable String namespace;
     private @Nullable String value;
 
-    NamespaceID(final @NotNull String formattedKey) throws HardIllegalArgumentException {
+    public NamespaceID(final @NotNull String formattedKey) throws HardIllegalArgumentException {
         set(formattedKey);
     }
 
-    NamespaceID(final @NotNull String namespace, final @NotNull String value) {
+    public NamespaceID(final @NotNull String namespace, final @NotNull String value) {
         set(namespace, value);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/util/debug/Debug.java b/game/core/src/main/java/net/minecraft/core/util/debug/Debug.java
index eccfb43ec..5abdf0960 100644
--- a/game/core/src/main/java/net/minecraft/core/util/debug/Debug.java
+++ b/game/core/src/main/java/net/minecraft/core/util/debug/Debug.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.util.debug;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import org.slf4j.Logger;
 
-import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
@@ -90,8 +90,8 @@ public class Debug {
 		
 		public final String name;
 		public Profiler parent;
-		public Map<String, Profiler> profilers = new HashMap<>();
-		public List<Profiler> allProfilers = new ArrayList<>();
+		public Map<String, Profiler> profilers = new Object2ObjectOpenHashMap<>();
+		public List<Profiler> allProfilers = new ObjectArrayList<>();
 		public long startTime = -1;
 		public long time = 0;
 		
@@ -104,15 +104,15 @@ public class Debug {
 			Profiler profiler = this.profilers.get(name);
 			if(profiler == null) {
 				profiler = new Profiler(name, this);
-				profilers.put(name, profiler);
-				allProfilers.add(profiler);
+                this.profilers.put(name, profiler);
+                this.allProfilers.add(profiler);
 			}
 			return profiler;
 		}
 		
 		@Override
 		public int hashCode() {
-			return name.hashCode();
+			return this.name.hashCode();
 		}
 		
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 473408139..8813b5145 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -14,12 +14,12 @@ public class MathHelper {
     public MathHelper() {
     }
 
-    public static float sin(float f) {
-        return SIN_TABLE[(int) (f * 10430.38F) & 0xffff];
+    public static float sin(float deg) {
+        return SIN_TABLE[(int) (deg * 10430.38F) & 0xffff];
     }
 
-    public static float cos(float f) {
-        return SIN_TABLE[(int) (f * 10430.38F + 16384F) & 0xffff];
+    public static float cos(float deg) {
+        return SIN_TABLE[(int) (deg * 10430.38F + 16384F) & 0xffff];
     }
 
     public static float sqrt_float(float f) {
@@ -73,18 +73,15 @@ public class MathHelper {
     }
 
     public static double clamp(double value, double min, double max) {
-        if (value > max) return max;
-        return Math.max(value, min);
+        return org.joml.Math.clamp(min, max, value);
     }
 
     public static float clamp(float value, float min, float max) {
-        if (value > max) return max;
-        return Math.max(value, min);
+        return org.joml.Math.clamp(min, max, value);
     }
 
     public static int clamp(int value, int min, int max) {
-        if (value > max) return max;
-        return Math.max(value, min);
+        return org.joml.Math.clamp(min, max, value);
     }
 
     public static byte clamp(byte value, byte min, byte max) {
@@ -93,11 +90,11 @@ public class MathHelper {
     }
 
     public static float lerp(float a, float b, float amount) {
-        return a + ((b - a) * amount);
+        return org.joml.Math.lerp(a, b, amount);
     }
 
     public static double lerp(double a, double b, double amount) {
-        return a + ((b - a) * amount);
+        return org.joml.Math.lerp(a, b, amount);
     }
 
     public static float unlerp(float a, float b, float value) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index 295b1be1a..03670e0ce 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -22,6 +22,7 @@ public class BlocksContainer implements MutableWorldSource {
     public final @NotNull World world;
     private final @NotNull Map<@NotNull TilePos, @NotNull BlockEntry> blockEntryMap = new HashMap<>();
     private @Nullable Entity lightRefEntity = null;
+    public float partialTick = 1f;
 
     public BlocksContainer(final @NotNull World world) {
         this.world = world;
@@ -119,7 +120,7 @@ public class BlocksContainer implements MutableWorldSource {
             return entry.id;
         }
 
-        return this.world.getBlockId(tilePos);
+        return 0;
     }
 
     @Override
@@ -134,13 +135,13 @@ public class BlocksContainer implements MutableWorldSource {
             return entry.tileEntity;
         }
 
-        return this.world.getTileEntity(tilePos);
+        return null;
     }
 
     @Override
     public float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission) {
         if (this.lightRefEntity != null) {
-            return this.lightRefEntity.getBrightness(1.0f);
+            return this.lightRefEntity.getBrightness(this.partialTick);
         }
 
         return this.world.getBrightness(tilePos, lightEmission);
@@ -149,7 +150,7 @@ public class BlocksContainer implements MutableWorldSource {
     @Override
     public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
         if (this.lightRefEntity != null) {
-            return this.lightRefEntity.getLightmap(1.0f);
+            return this.lightRefEntity.getLightmap(this.partialTick);
         }
 
         return this.world.getLightmapCoord(tilePos, lightEmission);
@@ -172,7 +173,7 @@ public class BlocksContainer implements MutableWorldSource {
             return entry.data;
         }
 
-        return this.world.getBlockData(tilePos);
+        return 0;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index b1373963b..20b7e44e6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -866,7 +866,7 @@ public class World implements MutableWorldSource {
         if (tilePos.y() < 0) {
             return 0;
         }
-        return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(new TilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z())), this.skyDarken);
+        return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z()), this.skyDarken);
     }
 
     public boolean canLoadedBlockSeeSky(final @NotNull TilePosc tilePos) {
@@ -1416,7 +1416,7 @@ public class World implements MutableWorldSource {
         if (f2 > 1.0F) {
             f2 = 1.0F;
         }
-        return f2 * f2 * 0.5F;
+        return f2 * f2;
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index ad5ca9ffa..572aa93be 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -33,6 +33,7 @@ public class Biome
     protected @NotNull List<@NotNull SpawnListEntry> spawnableWaterCreatureList = new ArrayList<>();
     protected @NotNull List<@NotNull SpawnListEntry> spawnableAmbientCreatureList = new ArrayList<>();
     private boolean hasSurfaceSnow = false;
+    private boolean hasSurfaceIce = false;
     
     public Biome(String key)
     {
@@ -102,12 +103,21 @@ public class Biome
     	return hasSurfaceSnow;
     }
 
+    public boolean hasSurfaceIce() {
+        return this.hasSurfaceIce;
+    }
+
     public Biome setSurfaceSnow()
     {
     	hasSurfaceSnow = true;
     	return this;
     }
 
+    public Biome setSurfaceIce() {
+        this.hasSurfaceIce = true;
+        return this;
+    }
+
     public Biome setBlockedWeathers(Weather... blocked)
     {
     	this.blockedWeathers = blocked;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 9e2c8d5b2..8fd5abe0a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -18,12 +18,12 @@ public class Biomes
     public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("overworld.grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
     public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("overworld.outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
     public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("overworld.shrubland").setColor(0xbaba38));
-    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow());
+    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow().setSurfaceIce());
     public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("overworld.boreal_forest").setColor(0x148564));
     public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("overworld.desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
     public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("overworld.plains").setColor(0xA3C649));
     public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
-    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow());
+    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow().setSurfaceIce());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22));
     public static final Biome DRIFT_DRIFT = register("minecraft:drift.drift", new BiomeDrift("drift.drift").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
     public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e));
@@ -46,10 +46,10 @@ public class Biomes
     public static final Biome OVERWORLD_LEGACY_FOREST = register("minecraft:overworld.legacy.forest", new BiomeForestLegacy("overworld.legacy.forest").setColor(0x056621));
     public static final Biome OVERWORLD_LEGACY_SAVANNA = register("minecraft:overworld.legacy.savanna", new BiomeDesertLegacy("overworld.legacy.savanna").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
     public static final Biome OVERWORLD_LEGACY_SHRUBLAND = register("minecraft:overworld.legacy.shrubland", new Biome("overworld.legacy.shrubland").setColor(0xa1ad20));
-    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow());
+    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow().setSurfaceIce());
     public static final Biome OVERWORLD_LEGACY_DESERT = register("minecraft:overworld.legacy.desert", new BiomeDesertLegacy("overworld.legacy.desert").setColor(0xfa9418).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
     public static final Biome OVERWORLD_LEGACY_PLAINS = register("minecraft:overworld.legacy.plains", new BiomeDesertLegacy("overworld.legacy.plains").setColor(0xffd910));
-    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow());
+    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow().setSurfaceIce());
 
     public static Biome register(String key, Biome biome)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
index 7696e8930..00f8aaf2f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
@@ -195,12 +195,14 @@ public class ChunkProviderThreaded implements IChunkProvider {
         }
 
         synchronized (this.loadedChunks) {
+            int count = 0;
             var itr = this.loadedChunks.entrySet().iterator();
             while (itr.hasNext()) {
                 var entry = itr.next();
                 ChunkPos pos = entry.getKey();
                 Chunk chunk = entry.getValue();
                 if (!isChunkValid(pos)) {
+                    count++;
                     saveChunk(chunk);
                     chunk.onUnload();
                     itr.remove();
@@ -208,6 +210,7 @@ public class ChunkProviderThreaded implements IChunkProvider {
                         this.lastQueriedChunkPos = MIN_POS;
                         this.lastQueriedChunk = this.empty;
                     }
+                    if (count > 4) break;
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
index 07c3243ab..f765aa206 100644
--- a/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/data/SynchedEntityData.java
@@ -3,8 +3,10 @@ package net.minecraft.core.world.data;
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
@@ -39,8 +41,8 @@ public class SynchedEntityData
     public static final int MAX_STRING_SIZE = 1024;
 
     public static final int END_MARKER = 0xFF;
-    private static final Object2IntMap<Class<?>> DATA_TYPES = new Object2IntArrayMap<>();
-    private final Int2ObjectMap<@NotNull DataItem<?>> itemsById = new Int2ObjectArrayMap<>();
+    private static final Object2IntMap<Class<?>> DATA_TYPES = new Object2IntOpenHashMap<>();
+    private final Int2ObjectMap<@NotNull DataItem<?>> itemsById = new Int2ObjectOpenHashMap<>();
     private boolean isDirty = true;
 
     /**
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
new file mode 100644
index 000000000..b1c7abc79
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -0,0 +1,79 @@
+package net.minecraft.core.world.generate;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.WorleyNoise;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2f;
+
+import java.util.Random;
+
+public class IceFloeLargeFeature
+    extends LargeFeature {
+    private @Nullable PerlinNoise perlinNoise = null;
+    private @Nullable PerlinNoise heightPerlinNoise = null;
+    private @Nullable World lastWorld = null;
+
+    @Override
+    protected void doGeneration(@NotNull final World world, @NotNull final Random random, final int chunkX, final int chunkZ, final int baseChunkX, final int baseChunkZ, @NotNull final ChunkGeneratorResult result) {
+        if (this.perlinNoise == null || this.heightPerlinNoise == null || this.lastWorld != world) {
+            this.perlinNoise = new PerlinNoise(world.getRandomSeed(), 4);
+            this.heightPerlinNoise = new PerlinNoise(world.getRandomSeed(), 8);
+            this.lastWorld = world;
+        }
+
+        final @NotNull WorldType worldType = world.getWorldType();
+        final int oceanY = worldType.getMinY() + worldType.getOceanY();
+
+        final @NotNull TilePos tilePos = new TilePos();
+        final @NotNull Vector2f vec = new Vector2f();
+        final @NotNull WorleyNoise.Result worley = new WorleyNoise.Result();
+
+        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+            for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
+                tilePos.set(Chunk.CHUNK_SIZE_X * baseChunkX + x, oceanY, Chunk.CHUNK_SIZE_Z * baseChunkZ + z);
+                final @NotNull Biome biome = world.getBlockBiome(tilePos);
+                if (biome == Biomes.OVERWORLD_GLACIER) {
+                    vec.x = baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X);
+                    vec.y = baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z);
+                    WorleyNoise.getWorleyDistance2d(vec, worley);
+                    final float scale = 10.0f;
+                    final float lineWidth = (float) (this.perlinNoise.get((baseChunkX * Chunk.CHUNK_SIZE_X + x) / scale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / scale) / 2.0 + 0.5);
+                    if (MathHelper.unsignedMod(worley.index, 15) != 0) {
+                        if (worley.distance > 0.9f + lineWidth * 0.05f) {
+                            continue;
+                        }
+                        for (int y = oceanY - 3; y < oceanY; y++) {
+                            this.trySetBlock(result, x, y, z, Blocks.PERMAICE.id());
+                        }
+                        for (int y = oceanY; y < oceanY + 1; y++) {
+                            this.trySetBlock(result, x, y, z, Blocks.BLOCK_SNOW.id());
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    private void trySetBlock(final @NotNull ChunkGeneratorResult result, final int x, final int y, final int z, final int id) {
+        final int current = result.getBlock(x, y, z);
+        if (current == Blocks.FLUID_WATER_STILL.id() || current == 0) {
+            result.setBlock(x, y, z, id);
+        }
+    }
+
+    @Override
+    public int getRadiusChunk() {
+        return 0;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
index 05722cd35..8577dbddf 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/LargeFeature.java
@@ -6,11 +6,11 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class LargeFeature {
+public abstract class LargeFeature {
     public LargeFeature() {
     }
 
-    public void generate(@NotNull World world, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
+    public final void generate(@NotNull World world, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
         int radius = getRadiusChunk();
         Random rand = new Random(world.getRandomSeed());
         long randX = (rand.nextLong() / 2L) * 2L + 1L;
@@ -24,8 +24,7 @@ public class LargeFeature {
         }
     }
 
-    protected void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
-    }
+    protected abstract void doGeneration(@NotNull World world, @NotNull Random random, int chunkX, int chunkZ, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result);
 
     public int getRadiusChunk() {
         return 8;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
index 1344d5d89..28b8e7d3b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
@@ -25,21 +25,6 @@ public class RetroCavesLargeFeature extends LargeFeature {
         this.maxY = maxY;
     }
 
-    @Override
-    public void generate(@NotNull World world, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result) {
-        int radius = getRadiusChunk();
-        Random rand = new Random(world.getRandomSeed());
-        long randX = (rand.nextLong() / 2L) * 2L + 1L;
-        long randZ = (rand.nextLong() / 2L) * 2L + 1L;
-        for (int chunkX = baseChunkX - radius; chunkX <= baseChunkX + radius; chunkX++) {
-            for (int chunkZ = baseChunkZ - radius; chunkZ <= baseChunkZ + radius; chunkZ++) {
-                rand.setSeed((long) chunkX * randX + (long) chunkZ * randZ ^ world.getRandomSeed());
-                doGeneration(world, rand, chunkX, chunkZ, baseChunkX, baseChunkZ, result);
-            }
-
-        }
-    }
-
     protected void generateHubRoom(@NotNull World world, @NotNull Random random, int baseChunkX, int baseChunkZ, @NotNull ChunkGeneratorResult result, double blockX, double blockY, double blockZ) {
         generateCave(world, random, baseChunkX, baseChunkZ, result, blockX, blockY, blockZ, 1.0F + random.nextFloat() * 6F, 0.0F, 0.0F, -1, -1, 0.5D);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 58afeae82..16fbdd278 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -101,7 +101,7 @@ public class ChunkDecoratorOverworld
             lakeChance = 0;
         if (lakeChance != 0 && rand.nextInt(lakeChance) == 0) {
             int fluid = Blocks.FLUID_WATER_STILL.id();
-            if (biome.hasSurfaceSnow()) {
+            if (biome.hasSurfaceIce()) {
                 fluid = Blocks.ICE.id();
             }
             int i1 = x + rand.nextInt(16) + 8;
@@ -608,7 +608,7 @@ public class ChunkDecoratorOverworld
                         this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if ((localBiome.hasSurfaceSnow() || this.world.worldType == WorldTypes.OVERWORLD_WINTER) && (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                if ((localBiome.hasSurfaceIce() || this.world.worldType == WorldTypes.OVERWORLD_WINTER) && (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())) {
                     this.world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
                 }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
index 8d2e7df5c..1394b695d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkGeneratorOverworld.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.CavesLargeFeature;
+import net.minecraft.core.world.generate.IceFloeLargeFeature;
 import net.minecraft.core.world.generate.LargeFeature;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import org.jetbrains.annotations.NotNull;
@@ -9,6 +10,6 @@ import org.jetbrains.annotations.NotNull;
 public class ChunkGeneratorOverworld
     extends ChunkGeneratorPerlin {
     public ChunkGeneratorOverworld(@NotNull World world) {
-        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new LargeFeature[]{new CavesLargeFeature()});
+        super(world, new ChunkDecoratorOverworld(world), new TerrainGeneratorOverworld(world), new SurfaceGeneratorOverworld(world), new LargeFeature[]{new CavesLargeFeature(), new IceFloeLargeFeature() });
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 2c651ab62..62f3b3300 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -2,9 +2,11 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 5f0bb0b67..343f4fafb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -306,7 +306,7 @@ public class ChunkDecoratorOverworldB173
                         this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if (localBiome.hasSurfaceSnow() && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                if (localBiome.hasSurfaceIce() && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
                     this.world.setBlockWithNotify(xx, oceanY - 1, zz, Blocks.ICE.id());
                 }
             }
